<?php
/**
 * Plumbing Services functions and definitions
 *
 * @package Plumbing Services
 */

if ( ! defined( 'PLUMBING_SERVICES_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'PLUMBING_SERVICES_VERSION', '1.0.0' );
}

function plumbing_services_setup() {

	load_theme_textdomain( 'plumbing-services', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( 'responsive-embeds' );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'plumbing-services' ),
			'social-menu' => esc_html__('Social Menu', 'plumbing-services'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'plumbing_services_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'plumbing_services_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $plumbing_services_content_width
 */
function plumbing_services_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'plumbing_services_content_width', 640 );
}
add_action( 'after_setup_theme', 'plumbing_services_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function plumbing_services_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'plumbing-services' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'plumbing-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'plumbing-services' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'plumbing-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'plumbing-services' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'plumbing-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'plumbing-services' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'plumbing-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'plumbing_services_widgets_init' );


function plumbing_services_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */
function plumbing_services_scripts() {

	// Load fonts locally
	require_once get_theme_file_path('revolution/inc/wptt-webfont-loader.php');

	$plumbing_services_font_families = array(
		'Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900',
		'Open Sans:ital,wght@0,300..800;1,300..800',
	);
	
	$plumbing_services_fonts_url = add_query_arg( array(
		'family' => implode( '&family=', $plumbing_services_font_families ),
		'display' => 'swap',
	), 'https://fonts.googleapis.com/css2' );

	wp_enqueue_style('plumbing-services-google-fonts', wptt_get_webfont_url(esc_url_raw($plumbing_services_fonts_url)), array(), '1.0.0');
	
	// Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

	wp_enqueue_style('owl.carousel.style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array());
	
	wp_enqueue_style( 'plumbing-services-style', get_stylesheet_uri(), array(), PLUMBING_SERVICES_VERSION );

	require get_parent_theme_file_path( '/custom-style.php' );
	wp_add_inline_style( 'plumbing-services-style',$plumbing_services_custom_css );

	wp_style_add_data('plumbing-services-style', 'rtl', 'replace');

	wp_enqueue_script( 'plumbing-services-navigation', get_template_directory_uri() . '/js/navigation.js', array(), PLUMBING_SERVICES_VERSION, true );

	wp_enqueue_script( 'owl.carousel.jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array(), PLUMBING_SERVICES_VERSION, true );

	wp_enqueue_script( 'plumbing-services-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), PLUMBING_SERVICES_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'plumbing_services_scripts' );

if (!function_exists('plumbing_services_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function plumbing_services_related_post($post_id){        
        $plumbing_services_categories = get_the_category($post_id);
        if ($plumbing_services_categories) {
            $plumbing_services_category_ids = array();
            $plumbing_services_category = get_category($plumbing_services_category_ids);
            $plumbing_services_categories = get_the_category($post_id);
            foreach ($plumbing_services_categories as $plumbing_services_category) {
                $plumbing_services_category_ids[] = $plumbing_services_category->term_id;
            }
            $plumbing_services_count = $plumbing_services_category->category_count;
            if ($plumbing_services_count > 1) { ?>

         	<?php
		$plumbing_services_related_post_wrap = absint(get_theme_mod('plumbing_services_enable_related_post', 1));
		if($plumbing_services_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('plumbing_services_related_post_text', __('Related Post', 'plumbing-services'))); ?></h2>
                    <?php
                    $plumbing_services_cat_post_args = array(
                        'category__in' => $plumbing_services_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'plumbing_services_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $plumbing_services_featured_query = new WP_Query($plumbing_services_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($plumbing_services_featured_query->have_posts()) :

                        while ($plumbing_services_featured_query->have_posts()) : $plumbing_services_featured_query->the_post();
                            ?>

							<div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php plumbing_services_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $plumbing_services_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/Faucet-Set.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $plumbing_services_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        plumbing_services_posted_on();
                                        plumbing_services_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('plumbing_services_related_posts', 'plumbing_services_related_post', 10, 1);

//Excerpt 
function plumbing_services_excerpt_function($plumbing_services_excerpt_count = 35) {
    $plumbing_services_excerpt = get_the_excerpt();
    $plumbing_services_text_excerpt = wp_strip_all_tags($plumbing_services_excerpt);
    $plumbing_services_excerpt_limit = (int) get_theme_mod('plumbing_services_excerpt_limit', $plumbing_services_excerpt_count);
    $plumbing_services_words = preg_split('/\s+/', $plumbing_services_text_excerpt); 
    $plumbing_services_trimmed_words = array_slice($plumbing_services_words, 0, $plumbing_services_excerpt_limit);
    $plumbing_services_theme_excerpt = implode(' ', $plumbing_services_trimmed_words);

    return $plumbing_services_theme_excerpt;
}


// Add admin notice
function plumbing_services_admin_notice() { 
    global $pagenow;
    $plumbing_services_theme_args      = wp_get_theme();
    $plumbing_services_meta            = get_option( 'plumbing_services_admin_notice' );
    $name            = $plumbing_services_theme_args->__get( 'Name' );
    $plumbing_services_current_screen  = get_current_screen();

    if( !$plumbing_services_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $plumbing_services_current_screen->base !== 'appearance_page_plumbing_services_guide' && 
            $plumbing_services_current_screen->base !== 'toplevel_page_plumbingservices-demoimport' ) { ?>

            <div class="notice notice-success plumbing-services-welcome-notice">
                <p class="plumbing-services-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'plumbing_services_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'plumbing-services' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="plumbing-services-welcome-notice-wrap">
                    <h2 class="plumbing-services-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $plumbing_services_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'plumbing-services' ), $plumbing_services_theme_name ) );
                        ?>
                    </h2>
                    <p class="plumbing-services-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'plumbing-services' ); ?>
                    </p>

                    <div class="plumbing-services-welcome-info">
                        <div class="plumbing-services-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'plumbing-services' ); ?>">
                        </div>

                        <div class="plumbing-services-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'plumbing-services' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'plumbing-services' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=plumbingservices-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'plumbing-services' ); ?></a></p>
                        </div>

                        <div class="plumbing-services-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'plumbing-services' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'plumbing-services' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=plumbing-services-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'plumbing-services' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'plumbing_services_admin_notice' );

if( ! function_exists( 'plumbing_services_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function plumbing_services_update_admin_notice(){
    if ( isset( $_GET['plumbing_services_admin_notice'] ) && $_GET['plumbing_services_admin_notice'] = '1' ) {
        update_option( 'plumbing_services_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'plumbing_services_update_admin_notice' );


add_action('after_switch_theme', 'plumbing_services_setup_options');
function plumbing_services_setup_options () {
    update_option('plumbing_services_admin_notice', FALSE );
}


/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$plumbing_services_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function plumbing_services_sanitize_checkbox($plumbing_services_checked)
{
    // Boolean check.
    return ((isset($plumbing_services_checked) && true == $plumbing_services_checked) ? true : false);
}

function plumbing_services_sanitize_choices( $plumbing_services_input, $plumbing_services_setting ) {
    global $wp_customize; 
    $plumbing_services_control = $wp_customize->get_control( $plumbing_services_setting->id ); 
    if ( array_key_exists( $plumbing_services_input, $plumbing_services_control->choices ) ) {
        return $plumbing_services_input;
    } else {
        return $plumbing_services_setting->default;
    }
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function plumbing_services_enqueue_function() {

	/**
	* GET START.
	*/
	require get_template_directory() . '/getstarted/plumbing_services_about_page.php';

	/**
	* DEMO IMPORT.
	*/
	require get_template_directory() . '/demo-import/plumbing_services_config_file.php';


	define('PLUMBING_SERVICES_FREE_SUPPORT',__('https://wordpress.org/support/theme/plumbing-services/','plumbing-services'));
	define('PLUMBING_SERVICES_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','plumbing-services'));
	define('PLUMBING_SERVICES_REVIEW',__('https://wordpress.org/support/theme/plumbing-services/reviews/#new-post','plumbing-services'));
	define('PLUMBING_SERVICES_BUY_NOW',__('https://www.revolutionwp.com/products/plumber-wordpress-theme','plumbing-services'));
	define('PLUMBING_SERVICES_LIVE_DEMO',__('https://demo.revolutionwp.com/plumbing-services-pro/','plumbing-services'));
	define('PLUMBING_SERVICES_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/plumbing-services-pro/','plumbing-services'));
	define('PLUMBING_SERVICES_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/plumbing-services-free','plumbing-services'));

}
add_action( 'after_setup_theme', 'plumbing_services_enqueue_function' );

function plumbing_services_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'plumbing_services_remove_customize_register', 11 );

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'plumbing_services_loop_columns');

if (!function_exists('plumbing_services_loop_columns')) {

	function plumbing_services_loop_columns() {

		$plumbing_services_columns = get_theme_mod( 'plumbing_services_per_columns', 3 );

		return $plumbing_services_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'plumbing_services_per_page', 20 );

function plumbing_services_per_page( $plumbing_services_cols ) {

  	$plumbing_services_cols = get_theme_mod( 'plumbing_services_product_per_page', 9 );

	return $plumbing_services_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'plumbing_services_products_args' );

function plumbing_services_products_args( $plumbing_services_args ) {

    $plumbing_services_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $plumbing_services_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $plumbing_services_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function plumbing_services_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --plumbing_services_logo_width: <?php echo absint(get_theme_mod('plumbing_services_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('plumbing_services_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'plumbing_services_custom_css' );

function get_changelog_from_readme() {
	$plumbing_services_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

	if (file_exists($plumbing_services_file_path)) {
		$plumbing_services_content = file_get_contents($plumbing_services_file_path);

		// Extract changelog section
		$plumbing_services_changelog_start = strpos($plumbing_services_content, "== Changelog ==");
		$plumbing_services_changelog = substr($plumbing_services_content, $plumbing_services_changelog_start);

		// Split changelog into versions
		preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $plumbing_services_changelog, $plumbing_services_matches, PREG_SET_ORDER);
		
		return $plumbing_services_matches;
	}
	return [];
}